#include "Block.h"
#include "Turnout.h"
#include "Route.h"
#include "R_Route.h"
#include "W_Route.h"
#include "Train.h"

#include "Define.h"

//------------------------------ Global variables --------------------------------------
//  Nota : in the names of variables, "clw" = "clockwise" and "cclw" = "conterclockwise"

byte block_line;
byte turnout_line;
byte route_line;
byte r_route_line;
byte w_route_line;
byte train_line = -1;

byte current_signal;
byte found_turnout;
boolean found_train;

byte origine_block;
byte extremity_block;
byte first_turnout;

byte final_level;
byte current_element;
byte current_priority;
byte total_pin_route;

boolean current_turnout_path;
boolean route_direction;

unsigned long last_route_date = 0;
unsigned long dateCourante;
unsigned long intervalle;
unsigned long dateDernierChangement;

boolean aClw_stop_zone_status = FREE;
boolean aCclw_stop_zone_status = FREE;
boolean aPlain_track_status  = FREE;

boolean test_000;
boolean test_001;
boolean test_010;
boolean test_011;
boolean test_100;
boolean test_101;
boolean test_110;
boolean test_111;
boolean memo_000;
boolean memo_001;
boolean memo_010;
boolean memo_011;
boolean memo_100;
boolean memo_101;
boolean memo_110;
boolean memo_111;
boolean block_direction;

byte pass = 0;
byte pass_direction = 0;

//---------------------------- Block -----------------------------
// current_block must be in [101 - 255] ==> MAX_BLOCK <= 155

Block blockList[MAX_BLOCK] =
{   Block(  0,101,102, 2),
    Block(101,102,103, 2),
    Block(102,103, 19, 2),
    Block( 19,104,  0, 2),
    Block(  1,105,  3, 4),
    Block(  1,106,  4, 6),
    Block(  2,107,  5, 8),
    Block(  2,108,  5,10),
    Block(  4,109,111, 6),
    Block(  5,110,112, 8),
    Block(109,111,113, 6),
    Block(110,112,114, 8),
    Block(111,113,116, 6),
    Block(112,114,115, 8),
    Block(114,115,117, 8),
    Block(113,116,118, 6),
    Block(115,117,  6, 8),
    Block(116,118,  8, 6),
    Block(  0,119, 18, 4),
    Block(  0,120, 18, 2),
    Block(  0,121, 17, 0),
    Block( 17,122, 10, 4),
    Block(  7,123, 15,10),
    Block(  7,124, 16, 8),
    Block(  9,125, 14, 6),
    Block( 11,126, 12, 4),
    Block( 11,127, 12, 2),
    Block( 15,128,  0,10),
    Block( 13,129,  0, 4),
    Block( 21,130,  1, 6),
    Block( 20,131,  2, 8)
};

//------------------------------ Turnout ---------------------------
// current_turnout must be in [1 - 100] ==> MAX_TURNOUT <= 100

Turnout turnoutList[MAX_TURNOUT] =
{   Turnout(130,  1,106,105, 6, 5, 30),
    Turnout(131,  2,107,108, 8, 9, 60),
    Turnout(105,  3,  4, 19, 4, 3, 30),
    Turnout(109,  4,106,  3, 6, 5, 30),
    Turnout(110,  5,107,108, 8, 9, 60),
    Turnout(117,  6,  7,  8, 8, 7, 30),
    Turnout(  6,  7,124,123, 8, 9, 30),
    Turnout(  9,  8,118,  6, 6, 7, 30),
    Turnout(  8,  9,125, 10, 6, 5, 30),
    Turnout( 11, 10,122,  9, 4, 5, 30),
    Turnout( 10, 11,126,127, 4, 3, 30),
    Turnout( 13, 12,126,127, 4, 3, 30),
    Turnout( 12, 13,129, 14, 4, 5, 30),
    Turnout( 21, 14,125, 13, 6, 5, 30),
    Turnout(123, 15,128, 16,10, 9, 30),
    Turnout( 20, 16,124, 15, 8, 9, 30),
    Turnout(122, 17, 18,121, 4, 0, 30),
    Turnout( 17, 18,119,120, 4, 2, 30),
    Turnout(104, 19,103,  3, 2, 3, 30),
    Turnout(131, 20, 16, 21, 8, 7, 30),
    Turnout( 14, 21,130, 20, 6, 7, 30)
};

//-------------------------- W_Route ------------------------------------

W_Route w_routeList[MAX_W_ROUTE];

//--------------------------- R_Route ----------------------------------------

R_Route r_routeList[MAX_R_ROUTE];

//-------------------------- Priorities in r_route --------------------------------

void Priorities()  //  Priorities is the order in which routes are calculated 
{
    r_routeList[ 0].setR_Priority(130);  r_routeList[ 0].setR_First( 1);
  
    r_routeList[ 1].setR_Priority(131);  r_routeList[ 1].setR_First( 2);
  
    r_routeList[ 2].setR_Priority(109);  r_routeList[ 2].setR_First( 4);
    r_routeList[ 3].setR_Priority(104);  r_routeList[ 3].setR_First(19);
    
    r_routeList[ 4].setR_Priority(110);  r_routeList[ 4].setR_First( 5);
  
    r_routeList[ 5].setR_Priority(117);  r_routeList[ 5].setR_First( 6);
    
    r_routeList[ 6].setR_Priority(118);  r_routeList[ 6].setR_First( 8);
  
    r_routeList[ 7].setR_Priority(122);  r_routeList[ 7].setR_First(17);
  
    r_routeList[ 8].setR_Priority(131);  r_routeList[ 8].setR_First(20);
    r_routeList[ 9].setR_Priority(130);  r_routeList[ 9].setR_First(21);
    r_routeList[10].setR_Priority(128);  r_routeList[10].setR_First(15);
    r_routeList[11].setR_Priority(129);  r_routeList[11].setR_First(13);
}
//--------------------------- Route ------------------------------------------

Route routeList[MAX_ROUTE];

byte new_route_init[] = {130,1, 131,2, 103,19, 105,3, 106,4, 107,5, 108,5, 117,6, 118,8, 119,18, 120,18, 121,17, 123,15, 124,16, 125,14, 126,12, 127,12};

//--------------------------- Pins ---------------------------------------

boolean pin_route[MAX_W_ROUTE];

//--------------------------- Train ----------------------------------------

Train trainList[MAX_TRAIN];

//****************************************************************************************************
//**                                             Setup()                                            **
//****************************************************************************************************

void setup()
{
    Serial.begin(115200);
    //----------------------------- Reset Wanted Route ------------------------------------------------
    // W_Routes is an alive table, constantly recalculated according to the wanted routes.
    
    for (byte i = 0; i < MAX_W_ROUTE; i++)
    {
        w_routeList[i].ResetW_Route();
    }
    W_Route::W_LineFirst();
  
    //----------------------------- Reset Reserved Route ------------------------------------------------
    // R_Routes is an alive table, constantly recalculated according to the reserved routes.
    
    for (byte i = 0; i < MAX_R_ROUTE; i++)
    {
        r_routeList[i].ResetR_Route();
    }  
    Priorities();
  
    //----------------------------- Reset Route ------------------------------------------------  
  
    for (byte i = 0; i < MAX_ROUTE; i++)
    {
        routeList[i].ResetRoute();
    }
    
    //----------------------------- Reset Train ------------------------------------------------  
  
    for (byte i = 0; i < MAX_TRAIN; i++)
    {
        trainList[i].ResetTrain();
    }
  
    //---------------------------------- pinMode() -----------------------------
    //---------------------------------------- Pin on Arduino MEGA----
    pinMode (78,  INPUT);   // sortie 0 port A
    pinMode (77,  INPUT);   // entrée 1 port A
    pinMode (76,  INPUT);   // entrée 2 port A
    pinMode (75,  INPUT);   // entrée 3 port A
    pinMode (74,  INPUT);   // entrée 4 port A
    pinMode (73,  INPUT);   // sortie 5 port A
    pinMode (72,  INPUT);   // sortie 6 port A
    pinMode (71,  INPUT);   // sortie 7 port A
    
    pinMode (19,  INPUT);   // sortie 0 port B
    pinMode (20,  INPUT);   // entrée 1 port B
    pinMode (21,  INPUT);   // entrée 2 port B
    pinMode (22,  INPUT);   // entrée 3 port B
    pinMode (23,  INPUT);   // entrée 4 port B
    pinMode (24,  INPUT);   // sortie 5 port B
    pinMode (25,  INPUT);   // sortie 6 port B
    pinMode (26,  INPUT);   // sortie 7 port B
    
    pinMode (53,  INPUT);   // sortie 0 port C
    pinMode (54,  INPUT);   // entrée 1 port C
    pinMode (55,  INPUT);   // entrée 2 port C
    pinMode (56,  INPUT);   // entrée 3 port C
    pinMode (57,  INPUT);   // entrée 4 port C
    pinMode (58,  INPUT);   // sortie 5 port C
    pinMode (59,  INPUT);   // sortie 6 port C
    pinMode (60,  INPUT);   // sortie 7 port C
}

//**************************************************************************************************
//**                                               loop()                                         **
//**************************************************************************************************
void loop()
{    
    unsigned long dateDernierChangement = micros();  
  
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
    //  ++    Il y a 2 x 9 x 12 = 216 itinéraires de la gare                                              ++
    //  ++    et l'Arduino trouve les 36 non possibles (il en reste donc 180) :                           ++
    //  ++    Je teste plusieurs situations simultannées, par des "copier-coller" d'essais,               ++
    //  ++    mais il n'en restera qu'une, gérée par les BP.                                              ++
    //  ++    Je teste un BP tout seul appuyé : il efface l'itinéraire demandé et éventuellement réservé  ++
    //  ++    Puis je teste 2 BP et c'est donc l'itinéraire demandé, puis réservé, puis réalisé           ++
    //  ++    quand les conditions sont remplies.                                                         ++
    //  ++    Cette partie "essais" est donc vouée à disparaitre                                          ++
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
    //------------------------------- Essais ------------------------------------------------------------
    
    pass = pass+1;
    switch (pass)
    {
        case 1 :
            //------------------------------- essai 130-105 ----------------------------
            pin_route[32] = true;
            R_Route::RouteChoice();
            pin_route[2] = true;
            R_Route::RouteChoice();
            pin_route[32] = false;
            pin_route[2] = false;
            R_Route::RouteChoice();
              
            //------------------------------- essai 105-109 ----------------------------  
            pin_route[3] = true;
            R_Route::RouteChoice();
            pin_route[10] = true;
            R_Route::RouteChoice();
            pin_route[3] = false;
            pin_route[10] = false;
            R_Route::RouteChoice();
          
            //------------------------------- essai 118-127 ----------------------------  
            pin_route[13] = true;
            R_Route::RouteChoice();
            pin_route[27] = true;
            R_Route::RouteChoice();
            pin_route[13] = false;
            pin_route[27] = false;
            R_Route::RouteChoice();
          
            //------------------------------- essai 127-131 ----------------------------  
            pin_route[28] = true;
            R_Route::RouteChoice();
            pin_route[33] = true;
            R_Route::RouteChoice();
            pin_route[28] = false;
            pin_route[33] = false;
            R_Route::RouteChoice();
      
             //------------------------------- essai 131-108 ----------------------------  
            pin_route[34] = true;
            R_Route::RouteChoice();
            pin_route[8] = true;
            R_Route::RouteChoice();
            pin_route[34] = false;
            pin_route[8] = false;
            R_Route::RouteChoice();
            
            //------------------------------- essai 108-110 ----------------------------  
            pin_route[9] = true;
            R_Route::RouteChoice();
            pin_route[11] = true;
            R_Route::RouteChoice();
            pin_route[9] = false;
            pin_route[11] = false;
            R_Route::RouteChoice();
      
            //------------------------------- essai 117-123 ----------------------------  
            pin_route[12] = true;
            R_Route::RouteChoice();
            pin_route[19] = true;
            R_Route::RouteChoice();
            pin_route[12] = false;
            pin_route[19] = false;
            R_Route::RouteChoice();
      
            //------------------------------- essai 123-128 ----------------------------  
            pin_route[20] = true;
            R_Route::RouteChoice();
            pin_route[29] = true;
            R_Route::RouteChoice();
            pin_route[20] = false;
            pin_route[29] = false;
            R_Route::RouteChoice();
                
            //--- essais pour initialiser la position des trains dans TraiList[] -------
      
            //  train 1
            blockList[29].setPlainTrackStatus0  (BUSY);
            blockList[29].setClwStopZoneStatus0 (BUSY);        
            
            break;
        case 2 :
      
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[ 4].setCclwStopZoneStatus0(BUSY);
            blockList[ 4].setPlainTrackStatus0  (BUSY);
            blockList[29].setPlainTrackStatus0  (FREE);
            blockList[29].setClwStopZoneStatus0 (FREE);
            blockList[ 4].setCclwStopZoneStatus0(FREE);
            blockList[ 4].setClwStopZoneStatus0 (BUSY);
              
            break;
        case 3 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----       
            //  train 1
      
            blockList[ 8].setCclwStopZoneStatus0(BUSY);
            blockList[ 8].setPlainTrackStatus0  (BUSY);
            blockList[ 4].setPlainTrackStatus0  (FREE);
            blockList[ 4].setClwStopZoneStatus0 (FREE);
            blockList[ 8].setCclwStopZoneStatus0(FREE);
            blockList[ 8].setClwStopZoneStatus0 (BUSY);
           
            break;    
        case 4 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[10].setCclwStopZoneStatus0(BUSY);
            blockList[10].setPlainTrackStatus0  (BUSY);
            blockList[ 8].setPlainTrackStatus0  (FREE);
            blockList[ 8].setClwStopZoneStatus0 (FREE);
            blockList[10].setCclwStopZoneStatus0(FREE);
            blockList[10].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 5 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[12].setCclwStopZoneStatus0(BUSY);
            blockList[12].setPlainTrackStatus0  (BUSY);
            blockList[10].setPlainTrackStatus0  (FREE);
            blockList[10].setClwStopZoneStatus0 (FREE);
            blockList[12].setCclwStopZoneStatus0(FREE);
            blockList[12].setClwStopZoneStatus0 (BUSY);
           
            break;    
        case 6 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[15].setCclwStopZoneStatus0(BUSY);
            blockList[15].setPlainTrackStatus0  (BUSY);
            blockList[12].setPlainTrackStatus0  (FREE);
            blockList[12].setClwStopZoneStatus0 (FREE);
            blockList[15].setCclwStopZoneStatus0(FREE);
            blockList[15].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 7 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[17].setCclwStopZoneStatus0(BUSY);
            blockList[17].setPlainTrackStatus0  (BUSY);
            blockList[15].setPlainTrackStatus0  (FREE);
            blockList[15].setClwStopZoneStatus0 (FREE);
            blockList[17].setCclwStopZoneStatus0(FREE);
            blockList[17].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 8 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[26].setCclwStopZoneStatus0(BUSY);
            blockList[26].setPlainTrackStatus0  (BUSY);
            blockList[17].setPlainTrackStatus0  (FREE);
            blockList[17].setClwStopZoneStatus0 (FREE);
            blockList[26].setCclwStopZoneStatus0(FREE);
            blockList[26].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 9 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[30].setCclwStopZoneStatus0(BUSY);
            blockList[30].setPlainTrackStatus0  (BUSY);
            blockList[26].setPlainTrackStatus0  (FREE);
            blockList[26].setClwStopZoneStatus0 (FREE);
            blockList[30].setCclwStopZoneStatus0(FREE);
            blockList[30].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 10 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[ 7].setCclwStopZoneStatus0(BUSY);
            blockList[ 7].setPlainTrackStatus0  (BUSY);
            blockList[30].setPlainTrackStatus0  (FREE);
            blockList[30].setClwStopZoneStatus0 (FREE);
            blockList[ 7].setCclwStopZoneStatus0(FREE);
            blockList[ 7].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 11 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[ 9].setCclwStopZoneStatus0(BUSY);
            blockList[ 9].setPlainTrackStatus0  (BUSY);
            blockList[ 7].setPlainTrackStatus0  (FREE);
            blockList[ 7].setClwStopZoneStatus0 (FREE);
            blockList[ 9].setCclwStopZoneStatus0(FREE);
            blockList[ 9].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 12 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[11].setCclwStopZoneStatus0(BUSY);
            blockList[11].setPlainTrackStatus0  (BUSY);
            blockList[ 9].setPlainTrackStatus0  (FREE);
            blockList[ 9].setClwStopZoneStatus0 (FREE);
            blockList[11].setCclwStopZoneStatus0(FREE);
            blockList[11].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 13 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[13].setCclwStopZoneStatus0(BUSY);
            blockList[13].setPlainTrackStatus0  (BUSY);
            blockList[11].setPlainTrackStatus0  (FREE);
            blockList[11].setClwStopZoneStatus0 (FREE);
            blockList[13].setCclwStopZoneStatus0(FREE);
            blockList[13].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 14 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[14].setCclwStopZoneStatus0(BUSY);
            blockList[14].setPlainTrackStatus0  (BUSY);
            blockList[13].setPlainTrackStatus0  (FREE);
            blockList[13].setClwStopZoneStatus0 (FREE);
            blockList[14].setCclwStopZoneStatus0(FREE);
            blockList[14].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 15 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[16].setCclwStopZoneStatus0(BUSY);
            blockList[16].setPlainTrackStatus0  (BUSY);
            blockList[14].setPlainTrackStatus0  (FREE);
            blockList[14].setClwStopZoneStatus0 (FREE);
            blockList[16].setCclwStopZoneStatus0(FREE);
            blockList[16].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 16 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[22].setCclwStopZoneStatus0(BUSY);
            blockList[22].setPlainTrackStatus0  (BUSY);
            blockList[16].setPlainTrackStatus0  (FREE);
            blockList[16].setClwStopZoneStatus0 (FREE);
            blockList[22].setCclwStopZoneStatus0(FREE);
            blockList[22].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 17 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
      
            blockList[27].setCclwStopZoneStatus0(BUSY);
            blockList[27].setPlainTrackStatus0  (BUSY);
            blockList[22].setPlainTrackStatus0  (FREE);
            blockList[22].setClwStopZoneStatus0 (FREE);
            blockList[27].setCclwStopZoneStatus0(FREE);
            blockList[27].setClwStopZoneStatus0 (BUSY);
            
            break;    
        case 18 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
            
            break;    
        case 19 :
            //---- essais pour que le sens des trains soit déterminé dans trainList[] ----
            //  train 1
            
            break;    
        default :
            pass = 0;  
    }
    
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
    //  ++                                     Suite du programme                                         ++
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
    //-----------------------------W_Route filling -------------------------------------------------------
  
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //  ++    Les itinéraires sont demandés via un BP origine et un BP extrémité sur le TCO.              ++
    //  ++    Le sens de l'itinéraire est demandé par l'ordre d'appui sur les BP.                         ++
    //  ++    Cette partie utilise le bus CAN n°2, mais n'est pas réalisée.                               ++
    //  ++    Mais le programme est donné ci-après entre les * *                                          ++
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    
    /*
    unsigned long current_date = millis();
    unsigned long intervalle = current_date - last_route_date;
  
    if (intervalle > 1000)  //  when a route is found, there is a delay of one second where we don't test the buttons
    {
        pin_route  [0] = PINA & B00000001;  // pin 78 (Arduino MEGA)
        pin_route  [1] = PINA & B00000010;  // pin 77
        pin_route  [2] = PINA & B00000100;  // pin 76
        pin_route  [3] = PINA & B00001000;  // pin 75
        pin_route  [4] = PINA & B00010000;  // pin 74
        pin_route  [5] = PINA & B00100000;  // pin 73
        pin_route  [6] = PINA & B01000000;  // pin 72
        pin_route  [7] = PINA & B10000000;  // pin 71
        pin_route  [8] = PINB & B00000001;  // pin 19
        pin_route  [9] = PINB & B00000010;  // pin 20
        pin_route [10] = PINB & B00000100;  // pin 21
        pin_route [11] = PINB & B00001000;  // pin 22
        pin_route [12] = PINB & B00010000;  // pin 23
        pin_route [13] = PINB & B00100000;  // pin 24
        pin_route [14] = PINB & B01000000;  // pin 25
        pin_route [15] = PINB & B10000000;  // pin 26
        pin_route [16] = PINC & B00000001;  // pin 53
        pin_route [17] = PINC & B00000010;  // pin 54
        pin_route [18] = PINC & B00000100;  // pin 55
        pin_route [19] = PINC & B00001000;  // pin 56
        pin_route [20] = PINC & B00010000;  // pin 57
       
        R_Route::RouteChoice();
    }
      
        pinMode (Broche_ZAG,      INPUT);
        pinMode (Broche_PV,       INPUT);
        pinMode (Broche_ZAD,      INPUT);
        pinMode (Broche_Sens,     OUTPUT);
        pinMode (Broche_Decroche, OUTPUT);
    
    */
  
    //--------------------------------- Exchange of the reserved routes --------------------------------------------------
    //  Calculation of all the w_route with status FREE
  
    for (byte i = 0; i < MAX_W_ROUTE; i++)
    {
        w_routeList[i].W_RouteStatusFree();
    }
  
    //  Calculation of all the w_route status, in the order of priorities
    for (byte i = 0; i < MAX_R_ROUTE; i++)
    {
        current_priority = r_routeList[i].getR_Priority();
    
        for (byte j = 0; j < MAX_W_ROUTE; j++)
        {
            if ((w_routeList[j].getW_StartBlock() == current_priority) || (w_routeList[j].getW_EndBlock() == current_priority))
            {
                if (w_routeList[j].getW_RouteStatus() == FREE)
                {
                    w_routeList[j].W_RouteStatus();
                }
            }
        }
    }
   
    for (byte i = 0; i < MAX_W_ROUTE; i++)
    {
        if (w_routeList[i].getW_RouteStatus() == RESERVED)
        //  Only the routes whose status is RESERVED can be exchanged between w_route and r_route
        {
          w_route_line = i;  //  It's #line of the route to exchange in W_Route
            for (byte j = 0; j < MAX_R_ROUTE; j++)
            {
                if ((r_routeList[j].getR_Priority() == w_routeList[w_route_line].getW_StartBlock()) && (r_routeList[j].getR_First() == w_routeList[w_route_line].getW_Turnout(0)))
                {
                    r_route_line = j;  // It's #line of the route to exchange in R_Route
                    r_routeList[r_route_line].R_RouteExchange();
                }
            }
    
          for (byte j = 0; j < MAX_R_ROUTE; j++)
            {
                if ((r_routeList[j].getR_Priority() == w_routeList[w_route_line].getW_EndBlock()) && (r_routeList[j].getR_First() == w_routeList[w_route_line].getW_Last())) 
                {
                    r_route_line = j;  // It's #line of the route to exchange in R_Route
                    r_routeList[r_route_line].R_RouteExchange();
                }
            }
        }
    }
  
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //  ++    L'Arduino DUE envoie toutes les positions aux aiguilles données                             ++
    //  ++    par la Classe des itinéraires réservés.                                                     ++
    //  ++    Cette partie utilise le bus CAN n°2, mais n'est pas réalisée.                               ++
    //  ++    Je vais ici forcer les positions dans la Classe Turnout.                                    ++
    //  ++    C'est l'objet du process suivant (voué, donc, à disparaître) :                              ++
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
    //----------------------------------- Put in position of turnouts -------------------------------------------
    
    for (byte i = 0; i < MAX_R_ROUTE; i++)
    {
        r_routeList[i].PutTurnoutPosition();    
    } 
    
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //  ++    L'Arduino DUE récupère toutes les positions réélles des aiguilles données par le réseau.    ++
    //  ++    Cette partie utilise le bus CAN n°2, mais n'est pas réalisée.                               ++
    //  ++    Ces positions sont mises à jour dans la Classe Turnout.                                     ++
    //  ++    Il reste à essayer tous les itinéraires pour savoir lesquels sont réalisés.                 ++
    //  ++    C'est l'objet du process suivant :                                                          ++
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
    //------------------------ Reset Route ---------------------------
    // Routes is an alive table, constantly recalculated according to the positions of turnouts.
    // So, it must be reset in the loop(), not in the setup().
  
    for (byte i = 0; i < MAX_ROUTE; i++)
    {
        routeList[i].ResetRoute();
    }
    
    //------------------------- Route filling -------------------------  
  
    for (byte i = 0; i < 2*MAX_ROUTE; i = i+2)
    {
        route_line = i/2;
        routeList[route_line].NewRouteInit(new_route_init[i],new_route_init[i+1]);
        routeList[route_line].TurnoutFilling();    
    }
  
    //--------------------- Next Block --------------------------
   
    for (byte i = 0; i < MAX_BLOCK; i++)
    {
        blockList[i].NextBlock();
    }
  
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //  ++                                    SIGNALS                                                     ++
    //  ++    The author being French, it is the french signalling which will be described                ++
    //  ++    The explanations of the french signals are in the tab define.h                              ++
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    
    Block::SignalsFilling();
  
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //  ++                                                                                                ++
    //  ++                     TRAINS : THE CASE OF THE DC : use the LOCODUINO cards                      ++
    //  ++                                                                                                ++
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //  ++                                                                                                ++
    //  ++                                TRAINS : THE CASE OF THE DCC                                    ++
    //  ++                                                                                                ++
    //  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
    //---------------------- Finding isolated trains --------------------------------------------
    //  The problem is to attribuate a line for each train in the trainList[]
    //  When a train is only on one block, whe create a new line in the trainList[]
    //  But if the block is already followed, we don't create a new line.
      
    Train::FindingIsolatedTrains();
    
    //-------------------------- Determining the direction of the trains -----------------------------------
    //  To find the direction of the train in DCC, without decodind DCC or XPressNet, we follow the train.
    //  Ther is three zones in a Block : stop zone clockwise, stop zone conterclockwise and the plain track, between the other zones.
    //  According to the various occupations of the zones, we can determine the direction of travel in only one block.
   
    Block::DeterminingTrainsDirections();
  
    //----------------------------- UpdateTrainList() ---------------------------
    //  Because trains move, we must update the trainList[]
  
    Train::UpdateTrainList();
  
    //---------------------- Problem of trains in opposition ----------------------
    //  If two Cn+2 Blocks are identical, it is because we have two trains which go in opposite sense there. The second has to have a "calculated" semaphore.
  
    Train::OppositeTrains();
    
    //------------------ Problem of the three blocks ---------------------------------
    //  A train cann't occupy simultaneously three blocks : there is a lost wagon
    
    Train::ThreeBlocks();
  /*    
    dateCourante = micros();
    intervalle = dateCourante - dateDernierChangement;
    
    Serial.println();
    Serial.println(intervalle);

    //------------------------- Results printing -----------------------
  
    Serial.println();
    for (byte i = 0; i < MAX_BLOCK; i++)
    {
        blockList[i].PrintBlock();
    }
  */
    Serial.println();  
    for (byte i = 0; i < MAX_TRAIN; i++)
    {
        trainList[i].PrintTrain();
    }
  /*
    Serial.println();  
    for (byte i = 0; i < MAX_TURNOUT; i++)
    {
        turnoutList[i].PrintTurnout();
    }
       
    Serial.println();
    Serial.println("Turnout path :");
    for (byte i=0; i < MAX_TURNOUT; i++)
    {
        Serial.println();
        Serial.println(turnoutList[i].getCurrentTurnout());
        Serial.println(turnoutList[i].getTurnoutPath());
    }
  */
    Serial.println();
    Serial.println("Wanted routes and turnouts positions :");
    for (byte i=0; i < MAX_W_ROUTE; i++)
    {
        Serial.println();
        w_routeList[i].PrintW_Route();
    }
  /*
    Serial.println();
    Serial.println("Reserved routes and turnouts positions :");
    for (byte i=0; i < MAX_R_ROUTE; i++)
    {
        Serial.println();
        r_routeList[i].PrintR_Route();
    }
  
    Serial.println();
    Serial.println("Made routes, depending of turnouts positions");
    for (byte i=0; i < MAX_ROUTE; i++)
    {
        Serial.println();
        routeList[i].PrintRoute();
    }
  */
}




